#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <error.h>
#include <errno.h>

//#define NULL ((void*)0)

void exit2() {
 printf("\nThank you for using the Quick Assembly SDK.");
 printf("\nDirect all questions, comments, flames, etc. to:");
 printf("\nseklorean@gmail.com\n\n");
 exit(0);
}

void fput_num(FILE *fp, int val) {
 static num = 0;
 if (val >= 256) val = val - 256;
 if (num % 16 == 0)
  fprintf(fp, "\n .db %i", val);
 else
  fprintf(fp, ",%i", val);
  num++;
}

void fput_num2(FILE *fp, int val) {
 static num = 0;
 if (val >= 256) val = val - 256;
 if (num % 16 == 0)
  fprintf(fp, "\n dc.b %i", val);
 else
  fprintf(fp, ",%i", val);
  num++;
}

void fput_num3(FILE *fp, int val, int sw) {
 static num = 0;
 if (val >= 256) val = val - 256;
 if (num % sw == 0)
  fprintf(fp, "},\n {%i", val);
 else
  fprintf(fp, ",%i", val);
  num++;
}

void read_pic(char *fname, char *new, int sw, int sh, char *ss) {
 FILE *fp,* nw;
 char header[62];
 char pic[9600];
 char buffer[9600];
 int x, y, z;

 if (sw > 320 || sh > 240 || sw < 0 | sh < 0) {
  printf("ERROR: Width or Height out of range.\n");
  exit2();
 }

 sw = sw / 8;
 z = sw * sh;

 fp = fopen(fname, "rb");

 if (fp == NULL) exit2();
 else {
  fread(&header, 62, 1, fp);
  fread(&buffer, z, 1, fp);
  fclose(fp);
  if (errno != 0) {
   printf("Error reading %s -- file is corrupt!\n", fname);
   exit2();
  }
 nw = fopen(new, "w");
 fprintf(nw, "; Monochrome Bitmap converted with QASM\n");
 if (strstr(ss,"C")) fprintf(nw, " static char pic[%i][%i] = {\n // Fixed { ", (sw * 8), sh);
 for(y = 0; y < sh; y++)
  for(x = 0; x < sw; x++) pic[(y * sw) + x] = buffer[(((sh - 1) - y) * sw) + x];
 for(x = 0; x < z; x++) {
  if (strstr(ss,"z80")) fput_num(nw, 255 - pic[x]);
  if (strstr(ss,"68k")) fput_num2(nw, 255 - pic[x]);
  if (strstr(ss,"C")) fput_num3(nw, 255 - pic[x], sw);
  }
 if (strstr(ss,"C")) fprintf(nw, "} }");
 }
 printf("\nDone!\n");
}

void main(int argc, char *argv[]) {
 FILE *fp;
 FILE *nw;
 char cde[2000];
 char cod[2000];
 char bckup[2000];
 char xc[5];
 char yc[100];
 int ti[10], x, y;

 if (argc == 1) {
  printf("\n\nProper Usage:\nqasm [INPUT_FILE] [OUTPUT_FILE] [OTHER] [width] [height] [style]\n\n");
  printf("[INPUT_FILE] is usually a .txt or .bmp file and\n");
  printf("[OUTPUT_FILE] is usually a .asm, .z80, .inc, or .h file.\n");
  printf("[OTHER] is the TI/Shell target or PIC for bitmap conversion\n");
  printf("TI/Shell: 82, 83, Ion1, MOS, DCS, Ion2, 85, 86\n");
  printf("[width] and [height] are bitmap dimensions, 320x240 max\n");
  printf("[style] is the format you want for bitmap data: z80, 68k, or C\n\n");
  printf("Please read QASM.html for more documentation.\n\n");
  exit2();
 }

 if (strstr(argv[3], "PIC")) {
  read_pic(argv[1], argv[2], atoi(argv[4]), atoi(argv[5]), argv[6]);
  exit2();
  }

 if (!strstr(argv[3], "PIC")) {
  nw = fopen(argv[2], "w");
  fflush(nw);

  if (strstr(argv[3], "82")) {
   fprintf(nw, ";crasm82\n\n.org $9104\n\n.db \"");
   printf("\nPlease Enter Description:");
   gets(cde);
   fprintf(nw, cde);
   fprintf(nw, "\",0\n\n");
   y = 82;
   }

  if (strstr(argv[3], "83")) {
   fprintf(nw, ";asm83\n\n.org $9327\n\n");
   y = 83;
   }

  if (strstr(argv[3], "DCS")) {
   fprintf(nw, "; Program Name:\n; Author:\n; Version:\n; Date:\n; Written for D");
   fprintf(nw, "oorc CS 7.0 and higher (http://dcs.cemetech.net)\n\n.nolist\n#in");
   fprintf(nw, "clude \"ti83plus.inc\"\n#include \"dcs7.inc\"\n.list\n.org progs");
   fprintf(nw, "tart\n .db $BB, $6D\nInit:\n xor d\n ret\n jr Start\n .dw Descri");
   fprintf(nw, "ption\n .db 7,0\n .dw Icon\n .dw 0\n\nDescription:\n.db \"");
   printf("\nPlease Enter Description:");
   gets(cde);
   fprintf(nw, cde);
   fprintf(nw, "\",0\n\nIcon:\n");
   for (x=0; x < 15; x++) fprintf(nw, ".db 0, 0\n");
   fprintf(nw, "\nStart:\n");
   y = 87;
   }

  if (strstr(argv[3], "Ion1")) {
   fprintf(nw, ";asm83\n\n.org $9327\n ret\n jr nc,Start\n\nIonInfo:\n.db \"");
   printf("\nPlease Enter Description:");
   gets(cde);
   fprintf(nw, cde);
   fprintf(nw, "\",0\n\nStart:\n");
   y = 89;
   }

  if (strstr(argv[3], "Ion2")) {
   fprintf(nw, ";asm83p\n\n.org $9D95\n ret\n jr nc,Start\n\nIonInfo:\n.db \"");
   printf("\nPlease Enter Description:");
   gets(cde);
   fprintf(nw, cde);
   fprintf(nw, "\",0\n\nStart:\n");
   y = 90;
   }

  if (strstr(argv[3], "8X")) {
   fprintf(nw, ";asm83p\n\n.org $9D95\n\n");
   y = 84;
   }

  if (strstr(argv[3], "MOS")) {
   fprintf(nw, ";asm83p\n\n.org $9D93\n.db $BB,$6D\n ret\n.db 1\n\nMOSsprite:\n");
   for (x = 0; x < 15; x++) fprintf(nw, ".db 0, 0\n");
   printf("\nPlease Enter Description:");
   gets(cde);
   fprintf(nw, "\n.db \"");
   fprintf(nw, cde);
   fprintf(nw, "\",0\n\n");
   y = 88;
   }

  if (strstr(argv[3], "85")) {
   printf("\nThe TI-85 is no longer supported.");
   exit2();
   }

  if (strstr(argv[3], "86")) {
   fprintf(nw, ";asm86\n\n.org $D748\n\n");
   y = 86;
   }

  }
  fflush(nw);

 if (argc == NULL) exit2();
 if ((fp = fopen(argv[1], "r")) != NULL) {
  if ((nw = fopen(argv[2], "a")) != NULL) {
   xc[4] = NULL;
   while(fgets(cde, sizeof(cde), fp)) {
    strcpy(bckup, "Hi");
    strcpy(cod, "Hi");
    if (strstr(cde, " SmlText($") || strstr(cde, " BigText($")) {
     strcpy(bckup, cde);
     xc[0] = cde[10];
     xc[1] = cde[11];
     xc[2] = cde[12];
     xc[3] = cde[13];
     strcpy(cod, strstr(cde, "\""));
     strcpy(cde, " ld de,$");
     strcat(cde, xc);
     }

    if (strstr(bckup, " SmlText($")) {
     ti[4] = 1;
     strcat(cde, "\n ld hl,$+6\n call PutSm\n.db ");
     strncat(cde, cod, strlen(cod) - 3);
     strcat(cde, ",0\n");
     }

    if (strstr(bckup, " BigText($")) {
     ti[1] = 1;
     strcat(cde, "\n ld hl,$+6\n call PutBig\n.db ");
     strncat(cde, cod, strlen(cod) - 3);
     strcat(cde, ",0\n");
     }

    if (strstr(cde, " Return")) strcpy(cde, " ret\n");
    if (strstr(cde, " NC_Return")) strcpy(cde, " ret nc\n");
    if (strstr(cde, " C_Return")) strcpy(cde, " ret c\n");
    if (strstr(cde, " Z_Return")) strcpy(cde, " ret z\n");
    if (strstr(cde, " NZ_Return")) strcpy(cde, " ret nz\n");
    if (strstr(cde, " P_Return")) strcpy(cde, " ret p\n");
    if (strstr(cde, " M_Return")) strcpy(cde, " ret m\n");
    if (strstr(cde, " PO_Return")) strcpy(cde, " ret po\n");
    if (strstr(cde, " PE_Return")) strcpy(cde, " ret pe\n");

    if (strstr(cde, " Is_A(")) {
     strcpy(cod, "");
     strncat(cod, cde, strlen(cde) - 2);
     strcpy(cde, " cp ");
     strcat(cde, strstr(cod, "A(")+2);
     strcat(cde, "\n");
     }

    if (strstr(cde, " For(")) {
     strcpy(cod, "");
     strncat(cod, cde, strlen(cde) - 3);
     strcpy(cde, "\n ld b");
     strcat(cde, strstr(cod, ","));
     strcat(cde, "\n");
     strncat(cde, strstr(cod, " For(") + 5, strlen(cde) - 6);
     strcat(cde, ":\n push bc\n");
     }

    if (strstr(cde, " EndFor(")) {
     strcpy(cod, "");
     strncat(cod, cde, strlen(cde) - 2);
     strcpy(cde, " pop bc\n djnz ");
     strncat(cde, strstr(cod, " EndFor(") + 8, strlen(cde) - 9);
     strcat(cde, "\n\n");
     }

    if (y == 86) {
     if (strstr(cde, " BusyOn")) strcpy(cde, " call $4AAD\n");
     if (strstr(cde, " NC_BusyOn")) strcpy(cde, " call nc,$4AAD\n");
     if (strstr(cde, " C_BusyOn")) strcpy(cde, " call c,$4AAD\n");
     if (strstr(cde, " NZ_BusyOn")) strcpy(cde, " call nz,$4AAD\n");
     if (strstr(cde, " Z_BusyOn")) strcpy(cde, " call z,$4AAD\n");
     if (strstr(cde, " P_BusyOn")) strcpy(cde, " call p,$4AAD\n");
     if (strstr(cde, " M_BusyOn")) strcpy(cde, " call m,$4AAD\n");
     if (strstr(cde, " PE_BusyOn")) strcpy(cde, " call pe,$4AAD\n");
     if (strstr(cde, " PO_BusyOn")) strcpy(cde, " call po,$4AAD\n");
     if (strstr(cde, " BusyOff")) strcpy(cde, " call $4AB1\n");
     if (strstr(cde, " NC_BusyOff")) strcpy(cde, " call nc,$4AB1\n");
     if (strstr(cde, " C_BusyOff")) strcpy(cde, " call c,$4AB1\n");
     if (strstr(cde, " Z_BusyOff")) strcpy(cde, " call z,$4AB1\n");
     if (strstr(cde, " NZ_BusyOff")) strcpy(cde, " call nz,$4AB1\n");
     if (strstr(cde, " P_BusyOff")) strcpy(cde, " call p,$4AB1\n");
     if (strstr(cde, " M_BusyOff")) strcpy(cde, " call m,$4AB1\n");
     if (strstr(cde, " PO_BusyOff")) strcpy(cde, " call po,$4AB1\n");
     if (strstr(cde, " PE_BusyOff")) strcpy(cde, " call pe,$4AB1\n");
     if (strstr(cde, " NewLine")) strcpy(cde, " call $4A5F\n");
     if (strstr(cde, " C_NewLine")) strcpy(cde, " call c,$4A5F\n");
     if (strstr(cde, " Z_NewLine")) strcpy(cde, " call z,$4A5F\n");
     if (strstr(cde, " NC_NewLine")) strcpy(cde, " call nc,$4A5F\n");
     if (strstr(cde, " NZ_NewLine")) strcpy(cde, " call nz,$4A5F\n");
     if (strstr(cde, " P_NewLine")) strcpy(cde, " call p,$4A5F\n");
     if (strstr(cde, " M_NewLine")) strcpy(cde, " call m,$4A5F\n");
     if (strstr(cde, " PO_NewLine")) strcpy(cde, " call po,$4A5F\n");
     if (strstr(cde, " PE_NewLine")) strcpy(cde, " call pe,$4A5F\n");
     if (strstr(cde, " Stop")) strcpy(cde, " jp $409C\n");
     if (strstr(cde, " Z_Stop")) strcpy(cde, " jp z,$409C\n");
     if (strstr(cde, " C_Stop")) strcpy(cde, " jp c,$409C\n");
     if (strstr(cde, " NZ_Stop")) strcpy(cde, " jp nz,$409C\n");
     if (strstr(cde, " NC_Stop")) strcpy(cde, " jp nc,$409C\n");
     if (strstr(cde, " P_Stop")) strcpy(cde, " jp p,$409C\n");
     if (strstr(cde, " M_Stop")) strcpy(cde, " jp m,$409C\n");
     if (strstr(cde, " PO_Stop")) strcpy(cde, " jp po,$409C\n");
     if (strstr(cde, " PE_Stop")) strcpy(cde, " jp pe,$409C\n");
     if (strstr(cde, " Pause")) strcpy(cde, " call $4D43\n");
     if (strstr(cde, " C_Pause")) strcpy(cde, " call c,$4D43\n");
     if (strstr(cde, " Z_Pause")) strcpy(cde, " call z,$4D43\n");
     if (strstr(cde, " NC_Pause")) strcpy(cde, " call nc,$4D43\n");
     if (strstr(cde, " NZ_Pause")) strcpy(cde, " call nz,$4D43\n");
     if (strstr(cde, " P_Pause")) strcpy(cde, " call p,$4D43\n");
     if (strstr(cde, " M_Pause")) strcpy(cde, " call m,$4D43\n");
     if (strstr(cde, " PO_Pause")) strcpy(cde, " call po,$4D43\n");
     if (strstr(cde, " PE_Pause")) strcpy(cde, " call pe,$4D43\n");
     if (strstr(cde, " ClLCD")) strcpy(cde, " call $4A7E\n");
     if (strstr(cde, " C_ClLCD")) strcpy(cde, " call c,$4A7E\n");
     if (strstr(cde, " NC_ClLCD")) strcpy(cde, " call nc,$4A7E\n");
     if (strstr(cde, " Z_ClLCD")) strcpy(cde, " call z,$4A7E\n");
     if (strstr(cde, " NZ_ClLCD")) strcpy(cde, " call nz,$4A7E\n");
     if (strstr(cde, " P_ClLCD")) strcpy(cde, " call p,$4A7E\n");
     if (strstr(cde, " M_ClLCD")) strcpy(cde, " call m,$4A7E\n");
     if (strstr(cde, " PO_ClLCD")) strcpy(cde, " call po,$4A7E\n");
     if (strstr(cde, " PE_ClLCD")) strcpy(cde, " call pe,$4A7E\n");
     if (strstr(cde, " C_DispG")) strcpy(cde, " call c,$4D6F\n");
     if (strstr(cde, " NC_DispG")) strcpy(cde, " call nc,$4D6F\n");
     if (strstr(cde, " Z_DispG")) strcpy(cde, " call z,$4D6F\n");
     if (strstr(cde, " NZ_DispG")) strcpy(cde, " call nz,$4D6F\n");
     if (strstr(cde, " DispG")) strcpy(cde, " call $4D6F\n");
     if (strstr(cde, " P_DispG")) strcpy(cde, " call p,$4D6F\n");
     if (strstr(cde, " M_DispG")) strcpy(cde, " call m,$4D6F\n");
     if (strstr(cde, " PO_DispG")) strcpy(cde, " call po,$4D6F\n");
     if (strstr(cde, " PE_DispG")) strcpy(cde, " call pe,$4D6F\n");
     if (strstr(cde, " ClrScrn")) strcpy(cde, " call $4A82\n");
     if (strstr(cde, " C_ClrScrn")) strcpy(cde, " call c,$4A82\n");
     if (strstr(cde, " NC_ClrScrn")) strcpy(cde, " call nc,$4A82\n");
     if (strstr(cde, " Z_ClrScrn")) strcpy(cde, " call z,$4A82\n");
     if (strstr(cde, " NZ_ClrScrn")) strcpy(cde, " call nz,$4A82\n");
     if (strstr(cde, " P_ClrScrn")) strcpy(cde, " call p,$4A82\n");
     if (strstr(cde, " M_ClrScrn")) strcpy(cde, " call m,$4A82\n");
     if (strstr(cde, " PO_ClrScrn")) strcpy(cde, " call po,$4A82\n");
     if (strstr(cde, " PE_ClrScrn")) strcpy(cde, " call pe,$4A82\n");
     if (strstr(cde, " HomeUp")) strcpy(cde, " call $4A95\n");
     if (strstr(cde, " C_HomeUp")) strcpy(cde, " call c,$4A95\n");
     if (strstr(cde, " NC_HomeUp")) strcpy(cde, " call nc,$4A95\n");
     if (strstr(cde, " Z_HomeUp")) strcpy(cde, " call z,$4A95\n");
     if (strstr(cde, " NZ_HomeUp")) strcpy(cde, " call nz,$4A95\n");
     if (strstr(cde, " P_HomeUp")) strcpy(cde, " call p,$4A95\n");
     if (strstr(cde, " M_HomeUp")) strcpy(cde, " call m,$4A95\n");
     if (strstr(cde, " PO_HomeUp")) strcpy(cde, " call po,$4A95\n");
     if (strstr(cde, " PE_HomeUp")) strcpy(cde, " call pe,$4A95\n");
     if (strstr(cde, " GetKey")) strcpy(cde, " call $55AA\n");
     if (strstr(cde, " C_GetKey")) strcpy(cde, " call c,$55AA\n");
     if (strstr(cde, " Z_GetKey")) strcpy(cde, " call z,$55AA\n");
     if (strstr(cde, " NC_GetKey")) strcpy(cde, " call nc,$55AA\n");
     if (strstr(cde, " NZ_GetKey")) strcpy(cde, " call nz,$55AA\n");
     if (strstr(cde, " P_GetKey")) strcpy(cde, " call p,$55AA\n");
     if (strstr(cde, " M_GetKey")) strcpy(cde, " call m,$55AA\n");
     if (strstr(cde, " PO_GetKey")) strcpy(cde, " call po,$55AA\n");
     if (strstr(cde, " PE_GetKey")) strcpy(cde, " call pe,$55AA\n");

     if (strstr(cde, " PutSml(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n call $4AA5\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutBig(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n call $4A37\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutCbg(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $4A2B\n");
      }
     if (strstr(cde, " PutCsm(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $4AA1\n");
      }

     }

    if (y == 83 || y == 87 || y == 89) {
     if (strstr(cde, " C_BusyOn")) strcpy(cde, " call c,$4791\n");
     if (strstr(cde, " NC_BusyOn")) strcpy(cde, " call nc,$4791\n");
     if (strstr(cde, " Z_BusyOn")) strcpy(cde, " call z,$4791\n");
     if (strstr(cde, " NZ_BusyOn")) strcpy(cde, " call nz,$4791\n");
     if (strstr(cde, " BusyOn")) strcpy(cde, " call $4791\n");
     if (strstr(cde, " P_BusyOn")) strcpy(cde, " call p,$4791\n");
     if (strstr(cde, " M_BusyOn")) strcpy(cde, " call m,$4791\n");
     if (strstr(cde, " PO_BusyOn")) strcpy(cde, " call po,$4791\n");
     if (strstr(cde, " PE_BusyOn")) strcpy(cde, " call pe,$4791\n");
     if (strstr(cde, " BusyOff")) strcpy(cde, " call $4795\n");
     if (strstr(cde, " C_BusyOff")) strcpy(cde, " call c,$4795\n");
     if (strstr(cde, " NC_BusyOff")) strcpy(cde, " call nc,$4795\n");
     if (strstr(cde, " Z_BusyOff")) strcpy(cde, " call z,$4795\n");
     if (strstr(cde, " NZ_BusyOff")) strcpy(cde, " call nz,$4795\n");
     if (strstr(cde, " P_BusyOff")) strcpy(cde, " call p,$4795\n");
     if (strstr(cde, " M_BusyOff")) strcpy(cde, " call m,$4795\n");
     if (strstr(cde, " PO_BusyOff")) strcpy(cde, " call po,$4795\n");
     if (strstr(cde, " PE_BusyOff")) strcpy(cde, " call pe,$4795\n");
     if (strstr(cde, " NewLine")) strcpy(cde, " call $473D\n");
     if (strstr(cde, " C_NewLine")) strcpy(cde, " call c,$473D\n");
     if (strstr(cde, " NC_NewLine")) strcpy(cde, " call nc,$473D\n");
     if (strstr(cde, " Z_NewLine")) strcpy(cde, " call z,$473D\n");
     if (strstr(cde, " NZ_NewLine")) strcpy(cde, " call nz,$473D\n");
     if (strstr(cde, " P_NewLine")) strcpy(cde, " call p,$473D\n");
     if (strstr(cde, " M_NewLine")) strcpy(cde, " call m,$473D\n");
     if (strstr(cde, " PO_NewLine")) strcpy(cde, " call po,$473D\n");
     if (strstr(cde, " PE_NewLine")) strcpy(cde, " call pe,$473D\n");
     if (strstr(cde, " Stop")) strcpy(cde, " ret ; Hopefully\n");
     if (strstr(cde, " C_Stop")) strcpy(cde, " ret c; Hopefully\n");
     if (strstr(cde, " NC_Stop")) strcpy(cde, " ret nc; Hopefully\n");
     if (strstr(cde, " Z_Stop")) strcpy(cde, " ret z; Hopefully\n");
     if (strstr(cde, " NZ_Stop")) strcpy(cde, " ret nz; Hopefully\n");
     if (strstr(cde, " P_Stop")) strcpy(cde, " ret p; Hopefully\n");
     if (strstr(cde, " M_Stop")) strcpy(cde, " ret m; Hopefully\n");
     if (strstr(cde, " PO_Stop")) strcpy(cde, " ret po; Hopefully\n");
     if (strstr(cde, " PE_Stop")) strcpy(cde, " ret pe; Hopefully\n");
     if (strstr(cde, " DispG")) strcpy(cde, " call $91B6\n");
     if (strstr(cde, " C_DispG")) strcpy(cde, " call c,$91B6\n");
     if (strstr(cde, " NC_DispG")) strcpy(cde, " call nc,$91B6\n");
     if (strstr(cde, " Z_DispG")) strcpy(cde, " call z,$91B6\n");
     if (strstr(cde, " NZ_DispG")) strcpy(cde, " call nz,$91B6\n");
     if (strstr(cde, " P_DispG")) strcpy(cde, " call p,$91B6\n");
     if (strstr(cde, " M_DispG")) strcpy(cde, " call m,$91B6\n");
     if (strstr(cde, " PO_DispG")) strcpy(cde, " call po,$91B6\n");
     if (strstr(cde, " PE_DispG")) strcpy(cde, " call pe,$91B6\n");
     if (strstr(cde, " ClLCD")) strcpy(cde, " call $4755\n");
     if (strstr(cde, " C_ClLCD")) strcpy(cde, " call c,$4755\n");
     if (strstr(cde, " NC_ClLCD")) strcpy(cde, " call nc,$4755\n");
     if (strstr(cde, " Z_ClLCD")) strcpy(cde, " call z,$4755\n");
     if (strstr(cde, " NZ_ClLCD")) strcpy(cde, " call nz,$4755\n");
     if (strstr(cde, " P_ClLCD")) strcpy(cde, " call p,$4755\n");
     if (strstr(cde, " M_ClLCD")) strcpy(cde, " call m,$4755\n");
     if (strstr(cde, " PO_ClLCD")) strcpy(cde, " call po,$4755\n");
     if (strstr(cde, " PE_ClLCD")) strcpy(cde, " call pe,$4755\n");
     if (strstr(cde, " ClrScrn")) strcpy(cde, " call $475D\n");
     if (strstr(cde, " C_ClrScrn")) strcpy(cde, " call c,$475D\n");
     if (strstr(cde, " NC_ClrScrn")) strcpy(cde, " call nc,$475D\n");
     if (strstr(cde, " Z_ClrScrn")) strcpy(cde, " call z,$475D\n");
     if (strstr(cde, " NZ_ClrScrn")) strcpy(cde, " call nz,$475D\n");
     if (strstr(cde, " P_ClrScrn")) strcpy(cde, " call p,$475D\n");
     if (strstr(cde, " M_ClrScrn")) strcpy(cde, " call m,$475D\n");
     if (strstr(cde, " PO_ClrScrn")) strcpy(cde, " call po,$475D\n");
     if (strstr(cde, " PE_ClrScrn")) strcpy(cde, " call pe,$475D\n");
     if (strstr(cde, " HomeUp")) strcpy(cde, " call $4775\n");
     if (strstr(cde, " Z_HomeUp")) strcpy(cde, " call z,$4775\n");
     if (strstr(cde, " C_HomeUp")) strcpy(cde, " call c,$4775\n");
     if (strstr(cde, " NZ_HomeUp")) strcpy(cde, " call nz,$4775\n");
     if (strstr(cde, " NC_HomeUp")) strcpy(cde, " call nc,$4775\n");
     if (strstr(cde, " P_HomeUp")) strcpy(cde, " call p,$4775\n");
     if (strstr(cde, " M_HomeUp")) strcpy(cde, " call m,$4775\n");
     if (strstr(cde, " PO_HomeUp")) strcpy(cde, " call po,$4775\n");
     if (strstr(cde, " PE_HomeUp")) strcpy(cde, " call pe,$4775\n");
     if (strstr(cde, " Pause")) strcpy(cde, " call $4CFE\n");
     if (strstr(cde, " C_Pause")) strcpy(cde, " call c,$4CFE\n");
     if (strstr(cde, " NC_Pause")) strcpy(cde, " call nc,$4CFE\n");
     if (strstr(cde, " Z_Pause")) strcpy(cde, " call z,$4CFE\n");
     if (strstr(cde, " NZ_Pause")) strcpy(cde, " call nz,$4CFE\n");
     if (strstr(cde, " P_Pause")) strcpy(cde, " call p,$4CFE\n");
     if (strstr(cde, " M_Pause")) strcpy(cde, " call m,$4CFE\n");
     if (strstr(cde, " PO_Pause")) strcpy(cde, " call po,$4CFE\n");
     if (strstr(cde, " PE_Pause")) strcpy(cde, " call pe,$4CFE\n");
     if (strstr(cde, " GetKey")) strcpy(cde, " call $4CFE\n");
     if (strstr(cde, " C_GetKey")) strcpy(cde, " call c,$4CFE\n");
     if (strstr(cde, " NC_GetKey")) strcpy(cde, " call nc,$4CFE\n");
     if (strstr(cde, " Z_GetKey")) strcpy(cde, " call z,$4CFE\n");
     if (strstr(cde, " NZ_GetKey")) strcpy(cde, " call nz,$4CFE\n");
     if (strstr(cde, " P_GetKey")) strcpy(cde, " call p,$4CFE\n");
     if (strstr(cde, " M_GetKey")) strcpy(cde, " call m,$4CFE\n");
     if (strstr(cde, " PO_GetKey")) strcpy(cde, " call po,$4CFE\n");
     if (strstr(cde, " PE_GetKey")) strcpy(cde, " call pe,$4CFE\n");

     if (strstr(cde, " PutSml(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n call $4781\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutBig(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n call $470D\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutCbg(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $4705\n");
      }
     if (strstr(cde, " PutCsm(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $477D\n");
      }
     }


    if (y == 84 || y == 88 || y == 90) {
     if (strstr(cde, " BusyOn")) strcpy(cde, " rst 28h\n .dw $456D\n");
     if (strstr(cde, " BusyOff")) strcpy(cde, " rst 28h\n .dw $4570\n");
     if (strstr(cde, " NewLine")) strcpy(cde, " rst 28h\n .dw $452E\n");
     if (y == 84 || y == 90) {
      if (strstr(cde, " Stop")) strcpy(cde, " ret ; Hopefully\n");
      if (strstr(cde, " C_Stop")) strcpy(cde, " ret c; Hopefully\n");
      if (strstr(cde, " NC_Stop")) strcpy(cde, " ret nc; Hopefully\n");
      if (strstr(cde, " Z_Stop")) strcpy(cde, " ret z; Hopefully\n");
      if (strstr(cde, " NZ_Stop")) strcpy(cde, " ret nz; Hopefully\n");
      if (strstr(cde, " P_Stop")) strcpy(cde, " ret p; Hopefully\n");
      if (strstr(cde, " M_Stop")) strcpy(cde, " ret m; Hopefully\n");
      if (strstr(cde, " PO_Stop")) strcpy(cde, " ret po; Hopefully\n");
      if (strstr(cde, " PE_Stop")) strcpy(cde, " ret pe; Hopefully\n");
     }
     if (strstr(cde, " DispG")) {
      strcpy(cde, " call DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " C_DispG")) {
      strcpy(cde, " call c,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " NC_DispG")) {
      strcpy(cde, " call nc,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " Z_DispG")) {
      strcpy(cde, " call z,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " NZ_DispG")) {
      strcpy(cde, " call nz,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " P_DispG")) {
      strcpy(cde, " call p,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " M_DispG")) {
      strcpy(cde, " call m,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " PO_DispG")) {
      strcpy(cde, " call po,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " PE_DispG")) {
      strcpy(cde, " call pe,DispG\n");
      ti[7] = 1;
     }
     if (strstr(cde, " ClLCD")) strcpy(cde, " rst 28h\n .dw $4540\n");
     if (strstr(cde, " ClrScrn")) strcpy(cde, " rst 28h\n .dw $4546\n");
     if (strstr(cde, " HomeUp")) strcpy(cde, " rst 28h\n .dw $4A5F\n");
     if (strstr(cde, " Pause")) strcpy(cde, " rst 28h\n .dw $4972\n");
     if (strstr(cde, " GetKey")) strcpy(cde, " rst 28h\n .dw $4972\n");
     if (y == 88) {
     if (strstr(bckup, " Stop")) strcpy(cde, " rst 28h\n .dw $40B9\n");
      }
     if (strstr(cde, " PutSml(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n rst 28h\n .dw $4561\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutBig(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+6\n rst 28h\n .dw $450A\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutCbg(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n rst 28h\n .dw $4504\n");
      }
     if (strstr(cde, " PutCsm(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n rst 28h\n .dw $455E\n");
      }
     }

    if (y == 82) {
     if (strstr(cde, " Stop")) strcpy(cde, " jp $8D88\n");
     if (strstr(cde, " C_Stop")) strcpy(cde, " jp c,$8D88\n");
     if (strstr(cde, " Z_Stop")) strcpy(cde, " jp z,$8D88\n");
     if (strstr(cde, " M_Stop")) strcpy(cde, " jp m,$8D88\n");
     if (strstr(cde, " P_Stop")) strcpy(cde, " jp p,$8D88\n");
     if (strstr(cde, " NC_Stop")) strcpy(cde, " jp nc,$8D88\n");
     if (strstr(cde, " NZ_Stop")) strcpy(cde, " jp nz,$8D88\n");
     if (strstr(cde, " PO_Stop")) strcpy(cde, " jp po,$8D88\n");
     if (strstr(cde, " PE_Stop")) strcpy(cde, " jp pe,$8D88\n");
     if (strstr(cde, " GetKey")) strcpy(cde, " call $01D4\n");
     if (strstr(cde, " C_GetKey")) strcpy(cde, " call c,$01D4\n");
     if (strstr(cde, " M_GetKey")) strcpy(cde, " call m,$01D4\n");
     if (strstr(cde, " P_GetKey")) strcpy(cde, " call p,$01D4\n");
     if (strstr(cde, " Z_GetKey")) strcpy(cde, " call z,$01D4\n");
     if (strstr(cde, " NC_GetKey")) strcpy(cde, " call nc,$01D4\n");
     if (strstr(cde, " NZ_GetKey")) strcpy(cde, " call nz,$01D4\n");
     if (strstr(cde, " PO_GetKey")) strcpy(cde, " call po,$01D4\n");
     if (strstr(cde, " PE_GetKey")) strcpy(cde, " call pe,$01D4\n");
     if (strstr(cde, " ClLCD")) strcpy(cde, " call $8D74\n.dw $389A\n");
     if (strstr(cde, " ClrScrn")) strcpy(cde, " call $8D74\n.dw $37A4\n");
     if (strstr(cde, " NewLine")) strcpy(cde, " call $8D74\n.dw $377A\n");
     if (strstr(cde, " DispG")) strcpy(cde, " call $8D74\n.dw $38AC\n");
     if (strstr(cde, " HomeUp")) strcpy(cde, " call $8D74\n.dw $3786\n");
     if (strstr(cde, " Pause")) {
      strcpy(cde, " call Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " C_Pause")) {
      strcpy(cde, " call c,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " P_Pause")) {
      strcpy(cde, " call p,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " Z_Pause")) {
      strcpy(cde, " call z,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " M_Pause")) {
      strcpy(cde, " call m,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " NC_Pause")) {
      strcpy(cde, " call nc,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " NZ_Pause")) {
      strcpy(cde, " call nz,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " PO_Pause")) {
      strcpy(cde, " call po,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " PE_Pause")) {
      strcpy(cde, " call pe,Pause\n");
      ti[5] = 1;
     }
     if (strstr(cde, " PutSml(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+8\n call $8D74\n.dw $37D4\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutBig(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld hl,$+8\n call $8D74\n.dw $38FA\n.db ");
      strncat(cde, cod, strlen(cod) - 3);
      strcat(cde, ",0\n");
      }
     if (strstr(cde, " PutCbg(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $8D74\n .dw $3738");
      }
     if (strstr(cde, " PutCsm(")) {
      strcpy(cod, strstr(cde, "\""));
      strcpy(cde, " ld a,'");
      strncat(cde, cod + 1, strlen(cod) - 3);
      strcat(cde, "'\n call $8D74\n .dw $37CE");
      }
    }

    if (strstr(cde, " InvText")) {
     strcpy(cde, " call InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " C_InvText")) {
     strcpy(cde, " call c,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " M_InvText")) {
     strcpy(cde, " call m,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " P_InvText")) {
     strcpy(cde, " call p,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " Z_InvText")) {
     strcpy(cde, " call z,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " NC_InvText")) {
     strcpy(cde, " call nc,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " NZ_InvText")) {
     strcpy(cde, " call nz,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " PE_InvText")) {
     strcpy(cde, " call pe,InvText\n");
     ti[2] = 1;
    }
    if (strstr(cde, " PO_InvText")) {
     strcpy(cde, " call po,InvText\n");
     ti[2] = 1;
    }

    if (strstr(cde, " ClrGraph")) {
     strcpy(cde, " call ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " PO_ClrGraph")) {
     strcpy(cde, " call po,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " C_ClrGraph")) {
     strcpy(cde, " call c,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " M_ClrGraph")) {
     strcpy(cde, " call m,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " P_ClrGraph")) {
     strcpy(cde, " call p,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " Z_ClrGraph")) {
     strcpy(cde, " call z,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " NC_ClrGraph")) {
     strcpy(cde, " call nc,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " NZ_ClrGraph")) {
     strcpy(cde, " call nz,ClrG\n");
     ti[3] = 1;
    }
    if (strstr(cde, " PE_ClrGraph")) {
     strcpy(cde, " call pe,ClrG\n");
     ti[3] = 1;
    }

    if (strstr(cde, " Sprite($")) {
     ti[6] = 1;
     strcpy(bckup, cde);
     xc[0] = cde[9];
     xc[1] = cde[10];
     xc[2] = cde[11];
     xc[3] = cde[12];
     xc[4] = NULL;
     yc[0] = cde[16];
     yc[1] = cde[17];
     yc[2] = cde[18];
     yc[3] = cde[19];
     yc[4] = NULL;
     strcpy(cod, strstr(cde, "\"") + 1);
     strcpy(cde, " ld de,$");
     strcat(cde, xc);
     strcat(cde, "\n ld hl,$");
     strcat(cde, yc);
     strcat(cde, "\n ld ix,");
     strncat(cde, cod, strlen(cod) - 4);
     strcat(cde, "\n call PutSprite\n");
     }

    fputs(cde, nw);
    fflush(nw);
  }

   if (ti[2] == 1) fprintf(nw, "\nInvText:\n bit 3,(iy+5)\n jr nz,ResText\n set 3,(iy+5)\n ret\nResText:\n res 3,(iy+5)\n ret\n");

   if (y == 86) {
    if (ti[1] == 1) fprintf(nw, "\nPutBig:\n ld a,d\n ld ($C00F),a\n ld a,e\n ld ($C010),a\n jp $4A37\n");
    if (ti[3] == 1) fprintf(nw, "\nClrG:\n ld hl,$C9FA\n ld de,$C9FB\n ld bc,$3FF\n ld (hl),0\n ldir\n ret\n");
    if (ti[4] == 1) fprintf(nw, "\nPutSm:\n ld a,d\n ld ($C37D),a\n ld a,e\n ld ($C37C),a\n jp $4AA5\n");
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d\nCore:\n ld a,(ix)\n ld (hl),");
     fprintf(nw, "a\n inc hl\n inc ix\n djnz Core\n ld bc,16\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n djnz DecLoop");
     fprintf(nw, "\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 83 || y == 87 || y == 89) {
    if (ti[1] == 1) fprintf(nw, "\nPutBig:\n ld a,d\n ld ($800C),a\n ld a,e\n ld ($800D),a\n jp $470D\n");
    if (ti[3] == 1) fprintf(nw, "\nClrG:\n ld hl,$8E29\n ld de,$8E2A\n ld bc,767\n ld (hl),0\n ldir\n ret\n");
    if (ti[4] == 1) fprintf(nw, "\nPutSm:\n ld a,d\n ld ($8253),a\n ld a,e\n ld ($8252),a\n jp $4781\n");
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld bc,14\n add ix,de\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d\nCore:");
     fprintf(nw, "\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n djnz Core\n ld bc,12\n add hl,bc\n ld b,d");
     fprintf(nw, "\nDecLoop:\n dec hl\n djnz DecLoop\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 82) {
    if (ti[1] == 1) fprintf(nw, "\nPutBig:\n ld a,d\n ld ($800C),a\n ld a,e\n ld ($800D),a\n call $8D74\n.dw $38FA\n ret\n");
    if (ti[3] == 1) fprintf(nw, "\nClrG:\n ld hl,$88B8\n ld de,$88B9\n ld bc,767\n ld (hl),0\n ldir\n ret\n");
    if (ti[4] == 1) fprintf(nw, "\nPutSm:\n ld a,d\n ld ($8216),a\n ld a,e\n ld ($8215),a\n call $8D74\n.dw $37D4\n ret\n");
    if (ti[5] == 1) fprintf(nw, "\nPause:\n call $01D4\n or a\n jr z,Pause\n ret\n");
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d\nCore:\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n");
     fprintf(nw, " djnz Core\n ld bc,12\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n djnz DecLoop\n pop bc\n djnz Height\n ret\n");
    }
   }

   if (y == 84 || y == 88 || y == 90) {
    if (ti[1] == 1) fprintf(nw, "\nPutBig:\n ld a,d\n ld ($844B),a\n ld a,e\n ld ($844C),a\n rst 28h\n .dw $450A\n ret\n");
    if (ti[3] == 1) fprintf(nw, "\nClrG:\n ld hl,$9340\n ld de,$9341\n ld bc,767\n ld (hl),0\n ldir\n ret\n");
    if (ti[4] == 1) fprintf(nw, "\nPutSm:\n ld a,d\n ld ($86D8),a\n ld a,e\n ld ($86D7),a\n rst 28h\n .dw $4561\n ret\n");
    if (ti[6] == 1) {
     fprintf(nw, "\nPutSprite:\n ld b,e\n xor c\nHeight:\n push bc\n ld b,d");
     fprintf(nw, "\nCore:\n ld a,(ix)\n ld (hl),a\n inc hl\n inc ix\n djnz Core");
     fprintf(nw, "\n ld bc,12\n add hl,bc\n ld b,d\nDecLoop:\n dec hl\n djnz DecLoop\n pop bc\n djnz Height\n ret\n");
    }
   if (ti[7] == 1) {
     fprintf(nw, "\nDispG:\n push af\n di\n ld a,$80\n out ($10),a\n ld hl,$9340+755");
     fprintf(nw, "\n ld a,$20\n ld c,a\n inc hl\n dec hl\nfastCopyAgain:\n ld b,64\n inc c\n ld de,-767\n ");
     fprintf(nw, "out ($10),a\n add hl,de\n ld de,10\nfastCopyLoop:\n add hl,de\n inc hl\n inc hl\n inc de\n ld a,(hl)");
     fprintf(nw, "\n out ($11),a\n dec de\n djnz fastCopyLoop\n ld a,c\n cp $2C\n jr nz,fastCopyAgain\n pop af\n ret\n");
    }
   }

   fflush(nw);
 }
  fprintf(nw, "\n\n.end");
  fflush(nw);
  printf("\n\nCongratulations!!!\nYour file is converted.\n");
  if (y == 82 || y == 87 || y == 88 || y == 89 || y == 90) {
   printf("Please use with ");
   if (y == 82) printf("Crash 1.6 on the TI-82.\n\n");
   if (y == 87) printf("Doors CS 7.0+ on the TI-83.\n\n");
   if (y == 88) printf("MirageOS on the TI-83+.\n\n");
   if (y == 89) printf("Ion 1.6 on the TI-83.\n\n");
   if (y == 90) printf("Ion 1.6 on the TI-83+.\n\n");
   }

  fcloseall();
 }
}

